/*
 * fuse_relay_board.h
 *
 * Created: 2014-01-28 18:08:44
 *  Author: pperek
 */ 


#ifndef FUSE_RELAY_BOARD_H_
#define FUSE_RELAY_BOARD_H_

#define MMC_LED				IOPORT_CREATE_PIN(PORTA, 0)

#define EXTERNAL_I2C_SDA	IOPORT_CREATE_PIN(PORTC, 0)
#define EXTERNAL_I2C_SCL	IOPORT_CREATE_PIN(PORTC, 1)
#define LOCAL_I2C_SDA_ERR	IOPORT_CREATE_PIN(PORTD, 0)
#define LOCAL_I2C_SCL_ERR	IOPORT_CREATE_PIN(PORTD, 1)
#define LOCAL_I2C_SDA		IOPORT_CREATE_PIN(PORTE, 0)
#define LOCAL_I2C_SCL		IOPORT_CREATE_PIN(PORTE, 1)

#define GPIO_1				IOPORT_CREATE_PIN(PORTC, 2)
#define GPIO_2				IOPORT_CREATE_PIN(PORTC, 3)
#define GPIO_3				IOPORT_CREATE_PIN(PORTC, 4)
#define GPIO_4				IOPORT_CREATE_PIN(PORTC, 5)
#define GPIO_5				IOPORT_CREATE_PIN(PORTC, 6)
#define GPIO_6				IOPORT_CREATE_PIN(PORTC, 7)
#define GPIO_7				IOPORT_CREATE_PIN(PORTD, 2)
#define GPIO_8				IOPORT_CREATE_PIN(PORTD, 3)
#define GPIO_9				IOPORT_CREATE_PIN(PORTD, 4)
#define GPIO_10				IOPORT_CREATE_PIN(PORTD, 5)
#define GPIO_11				IOPORT_CREATE_PIN(PORTD, 6)

#define CPLD_RESET			IOPORT_CREATE_PIN(PORTD, 7)

#define SPI_SS				IOPORT_CREATE_PIN(PORTE, 4)
#define SPI_MOSI			IOPORT_CREATE_PIN(PORTE, 5)
#define SPI_MISO			IOPORT_CREATE_PIN(PORTE, 6)
#define SPI_SCK				IOPORT_CREATE_PIN(PORTE, 7)

#define SUART_XCK			IOPORT_CREATE_PIN(PORTF, 1)
#define SUART_RX			IOPORT_CREATE_PIN(PORTF, 2)
#define SUART_TX			IOPORT_CREATE_PIN(PORTF, 3)
#define ON_OFF_FLIP_FLOP	IOPORT_CREATE_PIN(PORTF, 4)

#define CPLD_ADDR0			IOPORT_CREATE_PIN(PORTC, 2)
#define CPLD_ADDR1			IOPORT_CREATE_PIN(PORTC, 3)
#define CPLD_ADDR2			IOPORT_CREATE_PIN(PORTC, 4)
#define CPLD_ADDR3			IOPORT_CREATE_PIN(PORTC, 5)
#define CPLD_ADDR4			IOPORT_CREATE_PIN(PORTD, 6)

#define CPLD_DATA0			IOPORT_CREATE_PIN(PORTD, 3)
#define CPLD_DATA1			IOPORT_CREATE_PIN(PORTD, 4)
#define CPLD_DATA2			IOPORT_CREATE_PIN(PORTD, 5)
#define CPLD_DATA3			IOPORT_CREATE_PIN(PORTD, 6)

#define CPLD_READ			IOPORT_CREATE_PIN(PORTC, 7)
#define CPLD_CLOCK			IOPORT_CREATE_PIN(PORTD, 2)

#define SWITCH_UP			GPIO_1
#define SWITCH_DOWN			GPIO_2
#define CPLD_INTERRUPT		GPIO_3
#define CPLD_TMCB_JUMPER	GPIO_4

#define REVDET0             IOPORT_CREATE_PIN(PORTB, 2)  // FRED2 REV B
#define REVDET1             IOPORT_CREATE_PIN(PORTB, 1)  // FRED2 REV C
#define REVDET2             IOPORT_CREATE_PIN(PORTB, 0)  // FRED3M REV C
#define REVDET3             IOPORT_CREATE_PIN(PORTA, 7)  // FRED3 REV A
#define REVDET4             IOPORT_CREATE_PIN(PORTA, 6)  // FRED3 REV B
#define REVDET5             IOPORT_CREATE_PIN(PORTA, 5)  // FRED3M REV D

#endif /* FUSE_RELAY_BOARD_H_ */