/**
 * \file
 *
 * \brief User board initialization template
 *
 */

#include <asf.h>
#include <board.h>
#include <conf_board.h>
#include <ioport.h>

void board_init(void)
{
	//version detection ('active' on low)
	
	ioport_configure_pin(MMC_LED, IOPORT_DIR_OUTPUT);
	
	ioport_configure_pin(LOCAL_I2C_SCL_ERR, IOPORT_DIR_INPUT);
	ioport_configure_pin(LOCAL_I2C_SDA_ERR, IOPORT_DIR_INPUT);
	
	ioport_configure_pin(LOCAL_I2C_SCL, IOPORT_MODE_WIREDANDPULL);
	ioport_configure_pin(LOCAL_I2C_SDA, IOPORT_MODE_WIREDANDPULL);
	
	ioport_configure_pin(EXTERNAL_I2C_SDA, IOPORT_MODE_WIREDANDPULL);
	ioport_configure_pin(EXTERNAL_I2C_SCL, IOPORT_MODE_WIREDANDPULL);
	
	//USART	
	ioport_configure_pin(SUART_TX, IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	ioport_configure_pin(SUART_RX, IOPORT_DIR_INPUT);
	
/*	//CPLD parallel bus
	ioport_configure_pin(CPLD_ADDR0, IOPORT_DIR_OUTPUT);
	ioport_configure_pin(CPLD_ADDR1, IOPORT_DIR_OUTPUT);
	ioport_configure_pin(CPLD_ADDR2, IOPORT_DIR_OUTPUT);
	ioport_configure_pin(CPLD_ADDR3, IOPORT_DIR_OUTPUT);
	ioport_configure_pin(CPLD_ADDR4, IOPORT_DIR_OUTPUT);
	
	ioport_configure_pin(CPLD_READ,  IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	ioport_configure_pin(CPLD_CLOCK, IOPORT_DIR_OUTPUT | IOPORT_INIT_LOW);
	//ioport_configure_pin(CPLD_WRITE, IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	
	ioport_configure_pin(CPLD_DATA0, IOPORT_DIR_INPUT);
	ioport_configure_pin(CPLD_DATA1, IOPORT_DIR_INPUT);
	ioport_configure_pin(CPLD_DATA2, IOPORT_DIR_INPUT);
	ioport_configure_pin(CPLD_DATA3, IOPORT_DIR_INPUT);
*/
	ioport_configure_pin(SWITCH_UP, IOPORT_DIR_INPUT /* | IOPORT_SENSE_RISING */);
	ioport_configure_pin(SWITCH_DOWN, IOPORT_DIR_INPUT /*| IOPORT_SENSE_RISING */);
	ioport_configure_pin(CPLD_INTERRUPT, IOPORT_DIR_INPUT /*| IOPORT_SENSE_RISING*/);
	//SPI
	ioport_configure_pin(SPI_SS, IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	//ioport_configure_pin(SPI_SS, IOPORT_DIR_INPUT | IOPORT_PULL_UP);
	ioport_configure_pin(SPI_MOSI, IOPORT_INIT_HIGH | IOPORT_DIR_OUTPUT);
	ioport_configure_pin(SPI_MISO, IOPORT_DIR_INPUT);
	ioport_configure_pin(SPI_SCK, IOPORT_INIT_HIGH | IOPORT_DIR_OUTPUT);
	
	ioport_configure_pin(ON_OFF_FLIP_FLOP, IOPORT_DIR_INPUT);
    
    // Revision Definition Pins
    ioport_configure_pin(REVDET0, IOPORT_DIR_INPUT | IOPORT_PULL_UP);  // FRED2 REV B
    ioport_configure_pin(REVDET1, IOPORT_DIR_INPUT | IOPORT_PULL_UP);  // FRED2 REV C
    ioport_configure_pin(REVDET2, IOPORT_DIR_INPUT | IOPORT_PULL_UP);  // FRED3M REV C
    ioport_configure_pin(REVDET3, IOPORT_DIR_INPUT | IOPORT_PULL_UP);  // FRED3 REV A
    ioport_configure_pin(REVDET4, IOPORT_DIR_INPUT | IOPORT_PULL_UP);  // FRED3 REV B
    ioport_configure_pin(REVDET5, IOPORT_DIR_INPUT | IOPORT_PULL_UP);  // FRED3M REV D
}
