/**
 * \file
 *
 * \brief User board configuration template
 *
 */

#ifndef CONF_BOARD_H
#define CONF_BOARD_H

///Mode 0: Channel mask is read from TMCB2 board, all voltages are switched on/off if TMCB2 is not present
#define TMCB_HANDLE_MODE_0 0
///Mode 1: +15VD, -15VD is switched on/off, all other voltages stays
#define TMCB_HANDLE_MODE_1 1
///Mode 2: +15VD, -15VD is switched on/off and all other voltages will be switched on/off too
#define TMCB_HANDLE_MODE_2 2
///Mode 4: if all voltages are off, plugging tmcb does not turn voltages on, voltage off as in mode 1
#define TMCB_HANDLE_MODE_3 3


///The action for the TMCB handle
#define TMCB_HANDLE_MODE TMCB_HANDLE_MODE_3

#if !(TMCB_HANDLE_MODE == TMCB_HANDLE_MODE_0 || TMCB_HANDLE_MODE == TMCB_HANDLE_MODE_1 || TMCB_HANDLE_MODE == TMCB_HANDLE_MODE_2 || TMCB_HANDLE_MODE == TMCB_HANDLE_MODE_3)
	#error Wrong TMCB_HANDLE_MODE
#endif

/// No debug messages on UART
#define DEBUG_MSG_LEVEL_NONE 0
/// Error messages on UART
#define DEBUG_MSG_LEVEL_ERROR 1
/// Full debug output on UART
#define DEBUG_MSG_LEVEL_VERBOSE 2

///Debug messages configuration
#define DEBUG_MSG_LEVEL DEBUG_MSG_LEVEL_ERROR

#if (DEBUG_MSG_LEVEL >= DEBUG_MSG_LEVEL_ERROR)
	#define DBG_LEVEL_ERROR
#endif
#if (DEBUG_MSG_LEVEL >= DEBUG_MSG_LEVEL_VERBOSE)
	#define DBG_LEVEL_VERBOSE
#endif

#define PROTOCOL_VER_MAJOR	2
#define PROTOCOL_VER_MINOR	0
#define PROTOCOL_VER_REV	0

#endif // CONF_BOARD_H
