﻿/*
 * errors.h
 *
 * Created: 2015-08-25 13:37:26
 *  Author: Paweł
 */ 


#ifndef ERRORS_H_
#define ERRORS_H_

#include <stdint.h>

typedef struct ErrorCounter_s
{
	///Internal i2c bus
	unsigned totalTWIinternal;	
	unsigned errorsTWIinternal;
	
	///SN EEPROM
	unsigned totalSnEeprom;
	unsigned errorsSnEeprom;
	
	///POWER MONITORS
	unsigned totalPowerMonitor[8];
	unsigned errorsPowerMonitor[8];
	
	///External i2c bus
	unsigned totalTWIexternal;
	unsigned errorsTWIexternal;
	
	///FAN CONTROLLER
	unsigned totalFanController;
	unsigned errorsFanController;
	
	///FAN BOARD CPU
	unsigned totalFanboardCPU;
	unsigned errorsFanboardCPU;
	
	///TMCB MANAGEMENT
	unsigned totalTmcbMgmt;
	unsigned errorsTmcbMgmt;
	
	///SPI - CPLD
	unsigned totalSPICpld;
	unsigned errorsSPICpld;
} TransmissionStatistics;

void increment_i2c_internal(void);
void error_i2c_internal(void);

void increment_i2c_eeprom(int8_t status);

void increment_i2c_power_monitor(uint8_t number, int8_t status);

void increment_i2c_external(void);
void error_i2c_external(void);

void increment_fan_controller(int8_t status);

void increment_fanboard_cpu(int8_t status);

void increment_tmcb_mgmt(int8_t status);

void increment_spi_cpld(int8_t status);


void print_transmission_statistics(void);
#endif /* ERRORS_H_ */