﻿/*
 * events.c
 *
 * Created: 2015-09-29 23:44:16
 *  Author: Paweł
 */ 

#include "events.h"
#include "power_monitor.h"
#include "mgmt_protocol_master.h"

/**
 * \brief Process time driven events 
 * * TMCB handling
 * * on/off switching
 * * refreshing relays and structures
 * \param 
 * 
 * \return void
 */
void processEvents( void )
{
	if (tmcbJumperState)
	{
		processTmcbMgmt();
		if (!tmcbHandleOn() && tmcb_fpga_state == Not_configured)
		//Blue LED on if handle removed
			setTmcbBlueLed(REG_BLUE_LED_ON);
		if (tmcbHandleOn() && tmcb_fpga_state == Not_configured)
		//If handle pressed -> blue LED blink, turn on channels, 
		//	request enable FPGA
			powerOnTmcbHandle();
		else if (!tmcbHandleOn() && tmcb_fpga_state == Configured)
		//If handle pulled -> blue LED blink, request disable FPGA
			tmcbRequestDisableFpga();		
		if (tmcb_fpga_poweroff_request)
			powerOffTmcbHandle();
	}
	
	if (power_on_request)
		//power on - on switch or command
		powerBoxOn();
	if (power_down_request)
		//power down - disable FPGA if present
		powerBoxDown();
	if (power_off_request)
		//power off - disable voltages
		powerOff();
		
	updateRelays();
	processChannels(true);
}

